//------------------------------------------------------------//
//                                                            //
//  eϊ̖ʃNX                                  //
//                                                            //
//	Hiromu Itoh     2006                                      //
//                                                            //
//------------------------------------------------------------//
import java.awt.*;
import java.util.*;

public class ProjectionFace extends Face
{
	protected float color[] = {1.0f, 1.0f, 1.0f};

	public ProjectionFace()
	{
		this(1.0);
	}

	public ProjectionFace(double scale)
	{
		super(scale);
	}
	
	public ProjectionFace(double v[/*3*/][/*3*/])
	{
		super(v);
	}

	public ProjectionFace(Vector3d v[/*3*/])
	{
		super(v);
	}

	public ProjectionFace(Vector3d v[/*3*/], Vector2d texCoord[/*3*/])
	{
		super(v, texCoord);
	}

	public double getZ() {
		return center.getZ();
	}

	public void setColor(float red, float green, float blue) {
		color[0] = red;
		color[1] = green;
		color[2] = blue;
	}

	// eꂽʂ`悷
	public void draw(Vector2d winCenter, Vector2d winScale, Graphics g) {
		int x[] = new int[vertex.length];
		int y[] = new int[vertex.length];
		for (int i = 0; i < vertex.length; i++) {
			x[i] = (int)(winCenter.getX() + vertex[i].getX() * winScale.getX());
			y[i] = (int)(winCenter.getY() - vertex[i].getY() * winScale.getY());
		}

		g.setColor(new Color(color[0], color[1], color[2]));
		g.fillPolygon(x, y, vertex.length);
	}

	// eꂽʂRenderNXŕ`悷
	public void draw(Vector2d winCenter, Vector2d winScale, Render render) {
		int x[] = new int[vertex.length];
		int y[] = new int[vertex.length];
		for (int i = 0; i < vertex.length; i++) {
			x[i] = (int)(winCenter.getX() + vertex[i].getX() * winScale.getX());
			y[i] = (int)(winCenter.getY() - vertex[i].getY() * winScale.getY());
		}

		if (uv == null) {
			render.drawPolygon(new Vector3d(x[0], y[0], vertex[0].getZ()),
			                   new Vector3d(x[1], y[1], vertex[1].getZ()),
			                   new Vector3d(x[2], y[2], vertex[2].getZ()),
			                   (new Color(color[0], color[1], color[2])).getRGB());
		}
		else {
			render.drawPolygon(new Vector3d(x[0], y[0], vertex[0].getZ()),
			                   new Vector3d(x[1], y[1], vertex[1].getZ()),
			                   new Vector3d(x[2], y[2], vertex[2].getZ()),
			                   uv[0], uv[1], uv[2],
			                   (new Color(color[0], color[1], color[2])).getRGB());
		}
	}
}
